public class Quicksort {

	

	// relpos bruges i forbindelse med at vlge pivot-elementet tilfldigt i underarray'et

	public static double relpos = Math.random();



	

	// Udfrer selve quick-sort combine and conquer

	public static void QSort( int[] A, int p, int r ) {

		if (p < r) {

			int q = Partition( A, p, r );

			QSort( A, p, q );

			QSort( A, q+1, r );		

		} else return;

	}



	

	// Udfrer divide delen af QuickSort

	public static int Partition( int[] A, int p, int r ) {

		int x = A[p];

		//int x = A[(p+r)/2];

		//int x = A[ p + (int)(relpos*(r-p)) ];

		int i = p-1;

		int j = r+1;

		while (true) {

			do j--; while (A[j]>x);

			do i++; while (A[i]<x);

			if (i<j) {

				int y = A[j];

				A[j] = A[i];

				A[i] = y;

			} else return j;

		}

	

	}

	

	

	// Genererer tabel af tilfldige tal

	public static int[] rnd(int el) {

		int[] a = new int[el];

		

		for (int lp1=0; lp1<el; lp1++) 

			a[lp1] = (int)(Math.random()*el);

			

		return a;

	}



	

	// Konverterer tabel af tal til streng

	public static String arrstr(int[] A) {

		String r="";

		

		for (int lp1=0; lp1<A.length; lp1++)

			r += ""+A[lp1]+", ";

		

		return r;

	}

			

	

	// Hovedprogram.

	public static void main(String[] args) {

		int ec = Integer.parseInt(args[0]);

		int rc;

		if (args.length>1) rc = Integer.parseInt(args[1]);

		else rc = 1;

		

		long tottime = 0;

		

		

		// worst-case er allerede sorteret tabel, s lav det!

		int[] A = rnd(ec); QSort(A, 0, A.length-1);

		

		for (int lp1=0;lp1<rc; lp1++) {

			//int[] A = rnd(ec);

			if (ec<50) System.out.println("before: "+arrstr(A));

			long start = System.currentTimeMillis();

			QSort(A, 0, A.length-1);

			long end = System.currentTimeMillis();

			if (ec<50) System.out.println("after: "+arrstr(A));

			System.out.println("Time: "+(end-start)+" ms");

			tottime += (end-start);

		}

		System.out.println("Average: "+(double)(tottime)/rc +" ms");

	}

	

}



/* 1.000.000 * 100 = 1754 ms (n*lg(n) = 19931568,5 : k = 8,8e-5)

 * 100.000 * 100 = 139 ms ( 1660964,0 : k = 8,5e-5) 

 */