// Opgave 1:
//
// Da thetha(n) betyder c1*g(n) < f(n) < c2*g(n), alts at funktionen er begrnset bde opad og nedad.
// 1*n^2 < (2*n^2 -n) < 2*n^2, for tilstrkkelig store vrdier af n. 
// Funktionen n^2 afgrnser alts 2n^2-1 opad og nedad.


/* Opgave 2:
 
A:      31  41  59  26  41  58  11
Result: 59  41  58  26  31  41  11

B:      1  2  3  4  5  6  7  8  9  10  11  12
Result: 12  10  11  7  9  6  5  1  4  3  8  2

C:      20  19  18  17  16  15  14  13  12  11  1  2  3  4  5  6  7  8  9  10
Result: 20  19  18  17  16  15  14  13  12  11  1  2  3  4  5  6  7  8  9  10

Tilfldige numre:
Tid for	  1000 tal: 0ms
			 10000 tal: 0ms
			100000 tal: 50, 60 eller 110 ms - alts afhngig af den timeslice programmet tilfldigvis krer i.
*/

/* Source-kode: */
class Heap
{
	private int[] A;
	private int hsize = 0;
	Heap(int i) { A = new int[i]; }
	
 	public void insert(int key)
 	{
 		hsize++;
 		int i = hsize-1;
 		while (i > 0 && A[parent(i)] < key)
 		{
 			A[i] = A[parent(i)];
 			i = parent(i);
 		}
 	A[i] = key;
 		
 	}
 	
 public String toString() {
 	String s="";
 	for (int lp2 = 0; lp2<A.length; lp2++) s+=A[lp2]+ "  "	;
 	return s;
 }
 
 static public int parent(int index) { return (index+1)/2-1; }

static void main(String args[])
{
	// setup af data
	//int A[] = {31,41,59,26,41,58,11};
	//int A[] = {1,2,3,4,5,6,7,8,9,10,11,12};
	//int A[] = {20,19,18,17,16,15,14,13,12,11,1,2,3,4,5,6,7,8,9,10};
	
	// generering af mange tilfldige numre
	int A[] = new int[100000];
	for (int lp1 =0; lp1 < A.length; lp1++)
	{
		A[lp1] = (int)(Math.random()*A.length);
	}
	
	
	
	Heap result=new Heap(A.length);
	
	
	// print til skrm
/*	System.out.print("A:\t");
	for (int lp1 = 0; lp1 < A.length; lp1++) { System.out.print(A[lp1]+"  ");}	
	System.out.println("");
*/	
	// udfr indstning mv.
	long start = System.currentTimeMillis();
	for (int lp1 = 0; lp1 < A.length; lp1++) { result.insert(A[lp1]); }
	long slut= System.currentTimeMillis();
	
	// print til skrm
//	System.out.println("Result:\t" + result.toString() );
	System.out.println("Start: " + start );
	System.out.println("Slut:  " + slut );
	System.out.println("Tid: " + (slut-start) );
}

}
