class Heap {
	
	static void Heapify(int[] A, int i) // A er array, der skal heapifyes, i er indexnummer i A
	{
		int l = 0, r = 0, largest = 0, tmp = 0;
		
		l = 2*(i+1)-1; // da arrays i Java er index-0 baserede
		r = 2*(i+1)-0; //           -- || --
		if ( l < A.length && A[l] > A[i] ) largest = l;
			else largest = i;
		if ( r < A.length && A[r] > A[largest] ) largest = r;
		if ( largest != i ) 
		{
			tmp = A[largest];
			A[largest] = A[i];
			A[i] = tmp;
			
			Heapify(A, largest);
		}
		
	}
	
	static void Build_Heap(int[] A)
	{
		for (int i = A.length/2; i >= 0; i--)
		{
			Heapify(A,i);
		}
	}
	
	static void main(String args[])
	{
		//int A[] = {31,41,59,26,41,58,11};
		//int A[] = {1,2,3,4,5,6,7,8,9,10,11,12};
		int A[] = {20,19,18,1,17,16,15,14,13,12,11,2,3,4,5,6,7,8,9,10};
		for (int i = 0; i < A.length; i++) System.out.print(A[i] + "  ");
		System.out.println("");
		Build_Heap(A);
		for (int i = 0; i < A.length; i++) System.out.print(A[i] + "  ");	
	
		// TREEPRINT //
		System.out.println("\n\n*******************************************************************************");
		
		int arraydepth = (int)Math.ceil((Math.log(A.length)/Math.log(2)));
		int elcnt = 1;
		int fieldw = 80;
		int el = 0;
		
		for (int line = 0; line < arraydepth; line++) {
			for (int lp1 = 0; (lp1<elcnt) && (el<A.length); lp1++, el++) 
				System.out.print( field(A[el], fieldw) );
			System.out.println("");
			elcnt *= 2;
			fieldw /= 2;
		}					
	}
	
	static String field( int f, int width ) {
		String num = ""+f;
		int spacecnt = (width-num.length())/2;
		String spaces = "";
		
		for (;spacecnt>0; spacecnt--) spaces += " ";
		
		num = spaces + num + spaces;
		if (num.length()<width) num += " ";
		return num;
	}
		
}
	